/**
 * Created by Dev_Sun on 15. 9. 18..
 */
var cameraClass = {};



/* ========================================================== 설정 ==============================================================*/

// 이미지파일 url
cameraClass.fileURI= "";

// 이미지 사이즈
cameraClass.imgSize = 1600;

// 업로드 상태 확인
cameraClass.isuploading = false;

// 최근 실행모드 (카메라모드, 사진라이브러리모드)
cameraClass.lastAction = "";

//??
cameraClass.exifdata = "";

// 0 , 1 (라이브러리에서 가져올때 0, 직접 촬영시 1)
cameraClass.isDirectly = 0;



/* ========================================================== 카메라 초기 설정 ==============================================================*/
/*

 사진 전송
 @type : 0(사진 선택해서 올리기 ), 1(바로 찍어 올리기)
 @callback : 업로드 된 파일의 URL 반환 콜백 함수

 ex)

 uploadClass.photoupload(1,success);

 function success(fileurl){

 }

 */
cameraClass.pressCamera = function(type,isprofile){

    var sourceType = Camera.PictureSourceType.CAMERA;
    cameraClass.isDirectly = 1;
    cameraClass.lastAction = "camera";
    if(type == 1 ){
        sourceType = Camera.PictureSourceType.PHOTOLIBRARY;
        cameraClass.isDirectly = 0;
        cameraClass.lastAction = "select";
    }

    var option = { quality : 90,
        destinationType : navigator.camera.DestinationType.FILE_URI,
        sourceType : sourceType,

        //타겟사이즈 원본저장으로 변경, 사이즈를 지정해서 서버에서 이미지 리사이징(기폰 프로파일 설정)
        targetWidth: 1280,
        targetHeight: 640,//안드로이드는 세로사진이 가로로 원본 저장 되어있어 limit 사이즈를 반대로 설정

        encodingType: navigator.camera.EncodingType.JPEG,
        //encodingType: navigator.camera.EncodingType.PNG,
        mediaType : 0,
        allowEdit:false,
        correctOrientation: true,
        saveToPhotoAlbum: false };

    navigator.camera.getPicture(success,onFail,option);


    function success(imgurl){

        cameraClass.fileURI = imgurl;

        if(isprofile == true){
            // profile
            cameraClass.getProfileCallback(imgurl);
        }else{
            // confirm
            cameraClass.getPictureCallback(imgurl);
        }


    }

    function onFail(err){

    };
};
/* ========================================================== 카메라기능 콜백 ==============================================================*/
/*

 - success

 */


cameraClass.getPictureCallback= function(url){



        // 카메라 팝업 닫기
        eventmanagerClass.overlay_controll();

        // confirm 페이지 이동


        // 오늘 날씨 데이터
        var todayData = {}

        // 사진 URL
        todayData.photo = url
        //todayData.photo = "http://54.248.251.87:4000/file/2015/9/18/6/49/11/b2c4c837e2c3df82f9b9c393712cfdea80a5b4a3_1445118551748/11781445118510862_big.jpg"

        // 아이콘
        todayData.icon =  weatherApi.icon

        // 온도 (도씨, 화씨 변환)
        todayData.temp = utilClass.fixTemp(weatherApi.temp);

        // 지역
        todayData.area = locationClass.areaname.toUpperCase()

        // 날짜
        todayData.todayDate = configClass.todayDate;

        // 시간
        todayData.todayTime =  configClass.todayTime;


        eventmanagerClass.big_popup_view('confirm',todayData)

};

/* ========================================================== 프로필 카메라 콜백 ==============================================================*/



cameraClass.getProfileCallback=function(imgurl){
    var params = new Object();

    // 로그인 유저 아이디
    params.userid = loginClass.userid;

    // 프로필 설정
    params.isProfile = "true";

    // 이미지 사이즈 정사각형 크기로 출력시 필요
    params.imgoffsetX = 0;
    params.imgoffsetY = 0;

    params.filename =Math.floor((Math.random()*10000)+1) + currentDate.getTime().toString();

    //카메라 옵션
    var options = new FileUploadOptions();
    options.fileKey="imgs";
    options.fileName = params.filename+"_and.jpg";
    options.name = params.filename+"_and.jpg";
    options.mimeType="image/jpeg";
    options.testvalue = "test";
    options.params = params;

    var ft = new FileTransfer();
    ft.upload(imgurl, configClass.domain + "/file/upload?body="+encodeURI(JSON.stringify(params)), profileWin, profileFail, options);

};

// 사진 업로드 성공시 콜백
var profileWin = function(r) {

    if(r.responseCode != 200 && r.responseCode != "200"){
        utilClass.showMessage("Network Error");
        //utilClass.showMessage("Sorry~ Can't take");
        return;
    }
    var data = JSON.parse(r.response)
    var profileurl = data.results[0].user_profile;
    //$('[userData="'+loginClass.userid+'"]').attr("src",configClass.domain+profileurl+"_profile.jpg");
    $('[userData="'+loginClass.userid+'"]').css('background-image', 'url(' + configClass.domain+profileurl+"_profile.jpg" + ')')
    loginClass.profileimg = profileurl;
    storageClass.profileimg("set", loginClass.profileimg);
    eventmanagerClass.bottom_popup_hidden()


};


// 사진 업로드 실패시 콜백
var profileFail = function(error) {
    utilClass.showMessage("Profile Upload fail");

};


/* ========================================================== 프로필 삭제 ==============================================================*/
cameraClass.profileDelete = function (){
    $.post(utilClass.noneCachePostUrl(configClass.domain+'/api/profile_delete'), {
        userid:loginClass.userid
    }, function(data) {
        if(data ==  "error"){
            // 에러 팝업
        }else{

            $('[userData="'+loginClass.userid+'"]').css('background-image', 'url("./images/img_user_profile.png")')
            loginClass.profileimg = "./images/img_user_profile.png"
            storageClass.profileimg("set", loginClass.profileimg);
            eventmanagerClass.bottom_popup_hidden()
        }
    });
};


