var loginClass = {};

/* ========================================================== 로그인 정보 전역변수 처리 ================================================================*/

//전에 로그인 여부 체크
loginClass.autologincheck = "off";

//로그인 타입
loginClass.logintype = "";

// 로그인 유저 아이디 , 페이스북 로그인 유저 아이디
loginClass.userid = "";


// 유저 프로필 이미지
loginClass.profileimg = "";

// 유저 닉네임
loginClass.nickname = "";

// 유저 패스워드
loginClass.password = "";


/* 테스트 활성화 */
loginClass.testEnable =  false;

if(loginClass.testEnable ==  true){
    loginClass.autologincheck = "on";
    loginClass.userid = "";
}


/* ========================================================== 일반유저 회원가입 ================================================================*/
/*

 iddom : 아이디
 pwdom : 패스워드
 nickdom : 닉네임

 API Request : "signup"
 userid : 아이디
 nickname : 닉네임
 password : 패스워드
 areaname : 국가
 country : 지역

 */

loginClass.signup = function (){

    var userid = $("#email").val();
    var userpass = $("#password").val();
    var usernick = $("#nickname").val();


    //ID (email 입력하지 않은 경우)
    if(utilClass.validateEmail(userid) == false){
        utilClass.showMessage("Write Your email");
        return;
    }

    //PW & NICK 입력하지 않은 경우
    if(usernick == "" || usernick == "Nickname"){
        utilClass.showMessage("Write your nickname");
        return;
    }

    //패스워드 글자 수 최소제한
    if(userpass.length < 6){
        utilClass.showMessage("Too short password! Least 6 characters");
        return;
    }

    //패스워드 글자 수 최대제한
    if(30 < userpass.length){
        utilClass.showMessage("Too long password!");
        return;
    }

    // 회원가입 API Request
    $.post(utilClass.noneCachePostUrl(configClass.domain+'/api/signup'), {

        userid   : userid,
        nickname : usernick,
        password : userpass,
        profile  : "",
        areaname :  locationClass.areaname,
        country  :  locationClass.country

    }, function(data) {
        if(data == "ok"){

            // 로그인 처리
            loginClass.login(true,userid,userpass);


        }else if(data == "exist id"){

            // 아이디 중복처리
            utilClass.showMessage("Exist Id");

        }else if(data == "exist nick"){

            // 닉네임 중복처리
            utilClass.showMessage("Nickname already exist");

        }else{

            // 등록 실패처리
            utilClass.showMessage("Sign-up is failed");
        }
    });
};


/* ========================================================== 일반유저 로그인 ================================================================*/
/*

 API Request : "login"
 userid : 유저아이디,
 password : 패스워드
 auto : 회원가입 후 로그인 / 로그인

 */

loginClass.login = function(auto,id,pass){

    var id =id;
    var pass = pass;

    // 회원가입 후 로그인이 아닐 경우
    if(auto != true){
        id = $("#email").val();
        pass = $("#password").val();
    }

    $.post(utilClass.noneCachePostUrl(configClass.domain+'/api/login'), {
        userid : id,
        password : pass
    }, function(data) {

        // 정상 로그인
        if(data.code == "ok"){


            /*
             push token 설정 :
             if(typeof data.user_pushtoken == "undefined" ||  data.user_pushtoken == ""){
             initClass.initpush();
             }
             */

            console.log(data);

            /*
             user_areaname:
             user_ccl:
             user_ccl_rdate:
             user_country:
             user_fbemail:
             user_id:
             user_info:
             user_ismail:
             user_jointype:"
             user_logdate:
             user_more_address:
             user_more_city:
             user_more_country:
             user_more_email:
             user_more_firstname:
             user_more_lastname:
             user_more_zipcode:
             user_newslettervol:
             user_nickname:
             user_password:
             user_profile:
             user_pushtoken:
             user_rdate:
             user_rdate_format:
             user_registerSeller:
             user_userid:
             */

            // 프로필 이미지 없는 경우


            // 로그인 유저 데이터 저장
            loginClass.setlocalUserData(data.user_userid,pass,data.user_nickname,data.user_profile);

            // 로그인 여부 : on / off
            storageClass.logincheck("set","on");
            loginClass.autologincheck = "on";

            // 로그인 타입 설정
            storageClass.logintype("set","local");

            loginClass.loginCallback();



            // 로그인 실패
        }else if(data == "fail"){

            utilClass.showMessage("Check your ID or Password");

        }else{
            utilClass.showMessage("Login is failed");

        }
    });
};


/* ========================================================== 페이스북 로그인 ================================================================*/

loginClass.fbLogin = function(){
    // 권한 설정 및 접속요청
    facebookConnectPlugin.login(["public_profile","email"],

        // 접속 성공시 콜백호출
        function(){
            loginClass.fbLoginSuccess()
        },

        // 접속 실패시 콜백 호출
        function () {
            utilClass.showMessage("facebook login fail");
        }
    );
};

loginClass.fbLoginSuccess=function(){

    facebookConnectPlugin.getLoginStatus(function(response) {
        if (response.status == 'connected') {

            var uid = response.authResponse.userID;
            //var accessToken = response.authResponse.accessToken;

            //storageClass.fbuserid("set",uid);
            //storageClass.fbtoken("set",accessToken);

            facebookConnectPlugin.api("me/?fields=id,picture,email,name",[],
                function (result) {

                    var userInfodata = {};
                    userInfodata.id = result.id;
                    userInfodata.name = result.name;
                    userInfodata.email = result.email;
                    //alert(JSON.stringify(result))
                    userInfodata.profile = result.picture.data.url;

                    // 페이스북 유저 정보 DB 등록

                    loginClass.fbSign(userInfodata)

                },
                function (error) {
                    utilClass.showMessage("facebook error ");
                });

            // 앱과 페이스북 연결 실패
        } else if (response.status === 'not_authorized') {
            // the user is logged in to Facebook,
            // but has not authenticated your app
            utilClass.showMessage("facebook authenticated error");



            // 페이스북 접속 실패
        } else {
            utilClass.showMessage("user isn't logged in to Facebook");
        }
    });
};


/* ========================================================== 페이스북 정보 등록 ================================================================*/
/*

 API Request : "signup"
 userid : 페이스북 유저아이디
 nickname : 페이스뷱 유저 이름
 type : 접속 타입 ("facebook")
 userinfo : 페이스북 유저정보
 password : 페이스북 유저아이디

 */

loginClass.fbSign = function(data){

    $.post(utilClass.noneCachePostUrl(configClass.domain+'/api/signup'), {
        userid : data.id,
        nickname : data.name,
        profile: data.profile,
        email:data.email,
        type : "facebook",
        userinfo : JSON.stringify(data),
        password : data.id,
        areaname :  locationClass.areaname,
        country  :  locationClass.country
    }, function(result) {

        if(result == "error"){

            utilClass.showMessage("Sign-up is failed");
            return;
        }

        if(result == "ok" ) {

            // 페이스북유저 정보 로컬스토리 저장
            loginClass.setlocalUserData(data.id, data.id, data.name, data.profile);

        }else if(result.results == "exist id" ){

            // 페이스북유저 정보 로컬스토리 저장
            loginClass.setlocalUserData(result.list[0].user_userid,result.list[0].user_password,result.list[0].user_nickname,result.list[0].user_profile);
        }

        // 로그인 상태 접속상태 : on
        storageClass.logincheck("set", "on");
        loginClass.autologincheck = "on";

        // 로그인 타입 설정
        storageClass.logintype("set", "facebook");

        // 로그인 : 아웃 성공 처리
        loginClass.loginCallback()

    });

};



/* ========================================================== 로그아웃 ================================================================*/

loginClass.logout = function (){


    // 페이스북 계정 로그아웃
    var loginoutType = storageClass.logintype("get")
    if(loginoutType == "facebook"){
        facebookConnectPlugin.logout(
            function(){
                console.log("facebook logout")
            },function(){
                console.log("no facebook logout")
            });

    }
    // 로컬스토리지 보존
    var searchHistory = storageClass.searchHistory("get")
    var temp = storageClass.tempUnit("get")
    var wind = storageClass.windUnit("get")

    // 로컬스토리지 정보 삭제
    localStorage.clear();

    // 보존 로컬스토리 데이터 재 로드
    storageClass.searchHistory("set",searchHistory);
    storageClass.tempUnit("set",temp);
    storageClass.windUnit("set",wind);

    // 전역 변수 설정 초기화
    loginClass.autologincheck = "off";

    configClass.iskorean = false;

    //로그인 타입
    loginClass.logintype = "";

    loginClass.userid = "";

    // 유저 프로필 이미지
    loginClass.profileimg = "";

    // 유저 닉네임
    loginClass.nickname = "";

    // 유저 패스워드
    loginClass.password = "";


    // logout :express session 삭제

    $.post(utilClass.noneCachePostUrl(configClass.domain+'/api/logout'), {
    }, function(data) {
    });

    loginClass.loginCallback();

    // ChildBrowser plugin은 특정 URL 을 safari나 android의 웹브라우져가 아니라 어플리케이션내에서 새로운 창을 열어 해당 페이지를 보여주는 plugin이다.
    //if(!window.plugins.childBrowser){
    //    window.plugins.childBrowser = ChildBrowser.install();
    //}
    //window.plugins.childBrowser.LogOut();
};

/* ========================================================== 자동로그인 처리 ================================================================*/

loginClass.loginStart = function(callback){
    console.log("Login Check Start");

    //로그인 체크
    loginClass.autologincheck = storageClass.logincheck("get");

    if(loginClass.autologincheck == "on"){

        //loginClass.logintype = storageClass.logintype("get")
        loginClass.logininit(callback)

    }else{
        console.log("no Login callback");
        callback()
    }


    // 옵션 설정값 로드
    if(storageClass.tempUnit("get")!=" "  &&  storageClass.tempUnit("get") != null &&  storageClass.tempUnit("get") != 'null' &&  storageClass.tempUnit("get") != 'undefined' && storageClass.tempUnit("get") != undefined){
        configClass.temptype = storageClass.tempUnit("get");
    }

    if(storageClass.windUnit("get")!=" "  &&  storageClass.windUnit("get") != null &&  storageClass.windUnit("get") != 'null' &&  storageClass.windUnit("get") != 'undefined' && storageClass.windUnit("get") != undefined){
        configClass.windtype = storageClass.windUnit("get");
    }

};


//로그인 타입에 따라 페이스북/ 일반 로그인
loginClass.logininit=function(callback){

    // 유저 아이디
    loginClass.userid = storageClass.userid("get")

    // 유저 닉네임
    loginClass.password = storageClass.password("get");

    // 유저 프로필 이미지
    loginClass.profileimg = storageClass.profileimg("get");

    // 유저 닉네임
    loginClass.nickname = storageClass.nickname("get");

    // 온도, 풍속 설정값
    callback()
};


/* ========================================================== 패스워드 분실 ================================================================*/
/*

 API Request : "resetpasswd"
 userid : 로그인 유저 아이디 (이메일)

 */

loginClass.getPassword = function(){

    // 이메일 입력되지 않은 경우 처리
    if(utilClass.validateEmail($("#email").val()) == false || $("#email").val().length < 6){
        utilClass.showMessage("Write your email");
        return;
    }

    $.post(configClass.domain+'/api/resetpasswd', {
        userid : $("#email").val()
    }, function(data) {

        // 패스워드 리셋 성공시 패스워드 리셋요청 설정 초기화

        if(data.result == "ok"){
            utilClass.showMessage("Please, Check you email");
        }else if(data.result == "noexist"){
            utilClass.showMessage("Your e-mail address is wrong");
        }else{
            //todo::메일 전송 실패시 작업
            utilClass.showMessage("Network Error");
        }
    });
}



/* ==========================================================  유저정보 로컬스토리지 저장 ================================================================*/

loginClass.setlocalUserData = function (id, password, nick, profile){
    loginClass.userid = id;
    loginClass.password = password;
    loginClass.nickname = nick;
    loginClass.profileimg = profile;
    storageClass.userid("set",id);
    storageClass.password("set",password);
    storageClass.nickname("set",nick);
    storageClass.profileimg("set",profile);
};


/* ========================================================== 텍스트 입력창 초기화 ================================================================*/
loginClass.emailTextEmpty = function(){
    $("#email").val("")
}


/* ========================================================== 로그인페이지 OK 버튼 ================================================================*/

loginClass.loginOkbn = function(){
    var status = $("#tw-login-signup").attr("class")
    if(status == "login"){
        loginClass.login();
    }else{
        loginClass.signup()
    }
};

/* ========================================================== 로그인 / 아웃 성공 후 콜백  ================================================================*/

loginClass.loginCallback = function(){

    // 전체 페이지 초기화
    optionClass.optionResetApp("all")

};




