requirejs.config({
    baseUrl: 'js',

    /*
     기본경로 지정(폴더명)
     JavaScript 파일이 있는 기본 경로를 설정한다.
     만약 data-main 속성이 사용되었다면, 그 경로가 baseUrl이 된다.
     data-main 속성은 require.js를 위한 특별한 속성으로 require.js는 스크립트 로딩을 시작하기 위해 이 부분을 체크한다.
     */

    paths: {
        'jqurey':'./plugin/jquery-1.11.3.min',
        'j_tmpl':'./plugin/jquery.tmpl.min',
       // 'iscroll':'./plugin/iscroll',
       // 'iscroll_e':'./plugin/iscroll_edit',
        'iscroll_p':'./plugin/iscroll_probe',
        'j_form':'./plugin/jquery.form',
        'drawWindow':'./plugin/drawWindow',
        'swipeview_edit':'./plugin/swipeview_edit',
        'j_animate':'./plugin/jquery.animate-enhanced',
        'tappable':'./plugin/tappable',
        'canvas-to-blob':'./plugin/canvas-to-blob',
        'j_transit':'./plugin/jquery.transit',
        'jsOAuth_min':'./plugin/jsOAuth-1.3.4.min',
        'spin_min':'./plugin/spin.min',
        'j_lazyload':'./plugin/jquery.lazyload.edit',
        'fastclick':'./plugin/fastclick',
        'html2canvas':'./capture/html2canvas'



        /*
         예)
         'text': '../lib/require/text',
         'jquery': '../lib/jquery/jquery-1.7.min',
         'angular': '../lib/angular/angular-1.0.4'

         path는 baseUrl 아래에서 직접적으로 찾을 수 없는 모듈명들을 위해 경로를 매핑해주는 속성이다.
         "/"로 시작하거나 "http" 등으로 시작하지 않으면, 기본적으로는 baseUrl에 상대적으로 설정하게 된다.
         */
    },

    shim : {
        /*
         AMD 형식을 지원하지 않는 라이브러리의 경우 아래와 같이 shim을 사용해서 모듈로 불러올 수 있다.
         참고 : http://gregfranko.com/blog/require-dot-js-2-dot-0-shim-configuration/
         */

    }
});



require([

    'jqurey'


],function(){
    //페이지가 완전히 로드된 뒤에 실행


    require([
        'j_tmpl',
      //  'iscroll',
       // 'iscroll_e',
        'iscroll_p',
        'j_form',
        'drawWindow',
        'swipeview_edit',
        'j_animate',
        'tappable',
        'canvas-to-blob',
        'j_transit',
        'jsOAuth_min',
        'spin_min',
        'j_lazyload',
        'fastclick',
        'html2canvas',

        '../www/js/plugin/bootstrap.min.js',

        '../www/js/core/jsfile/notice.js',
        '../www/js/core/jsfile/option.js',
        '../www/js/core/jsfile/search.js',
        '../www/js/core/jsfile/util.js',
        '../www/js/core/jsfile/user.js',
        '../www/js/core/jsfile/share.js',
        '../www/js/core/jsfile/detailview.js',
        '../www/js/core/jsfile/discover.js',
        '../www/js/core/jsfile/confirm.js',
        '../www/js/core/jsfile/camera.js',
        '../www/js/core/jsfile/eventmanager.js',
        '../www/js/core/jsfile/pagemanager.js',

        '../www/js/core/jsfile/main_logic.js',
        '../www/js/core/jsfile/scroll.js',
        '../www/js/core/jsfile/loadDom.js',
        '../www/js/core/jsfile/weatherApi.js',
        '../www/js/core/jsfile/location.js',
        '../www/js/core/jsfile/storage.js',
        '../www/js/core/jsfile/login.js',
        '../www/js/core/jsfile/common.js',
        '../www/js/core/jsfile/config.js',


        /*
         디펜던시가 걸려있으므로, 이 디펜던시들이 먼저 로드된 뒤에 아래 콜백이 수행된다.

         예)
         'text', //미리 선언해둔 path, css나 html을 로드하기 위한 requireJS 플러그인
         'jquery', //미리 선언해둔 path, jQuery는 AMD를 지원하기 때문에 이렇게 로드해도 jQuery 또는 $로 호출할 수 있다.
         'angular' //미리 선언해둔 path
         */

    ],function(jquery,jqlist,jqlist2,jqlist3){                  //디펜던시 로드뒤 콜백함수. 로드된 디펜던시들은 콜백함수의 인자로 넣어줄 수 있다.(순서대로)

        /*
         //이 콜백 함수는 위에 명시된 모든 디펜던시들이 다 로드된 뒤에 호출된다.
         //주의해야할 것은, 디펜던시 로드 완료 시점이 페이지가 완전히 로드되기 전 일 수도 있다는 사실이다.
         //이 콜백함수는 생략할 수 있다.
         */
        require(['../www/js/core/core.js'],function(){
            //페이지가 완전히 로드된 뒤에 실행
            $(document).ready(function () {
                console.log("require loadcomplete");
                appStart();

            });


        });


    });


});

