/**
 * Created by Dev_Sun on 15. 8. 21..
 */
var searchClass = {};


/* ========================================================== location 페이지 초기실행 ==============================================================*/

searchClass.searchInit = function(type){


    // 텍스트 이벤트 활성화 및 검색 지역 로드
    searchClass.searchEvent();

    // Suggest 검색 로드
    searchClass.searchSuggest();
    // 최근 검색 내역 로드
    searchClass.searchHistory();


};


/* ========================================================== Suggest 검색 로드  ==============================================================*/
/*

 API Request : "readcity"
 count : 사진장수 (지역사진이 count 수 이상인 곳만 로드)

 */

searchClass.searchSuggest = function(){

    $.post(utilClass.noneCachePostUrl(configClass.domain+'/api/readcity'), {
        count:8
    }, function(result) {

        // 데이터 없을경우 return 처리
        if(typeof(result.list) == "undefined" || result.list.length<1){
            return;
        }

        for (var i in result.list){
            $(".location-suggest").css("display","block")

            var data = {};

            data.areaname = result.list[i].post_areaname;
            data.lat =  result.list[i].post_latitude;
            data.long =  result.list[i].post_longitude;
            data.country =  result.list[i].post_country;



            commonClass.appendDom("#suggestList","locationSuggest",data)
        }

    });
}



/* ========================================================== 최근 검색 내역 로드  ==============================================================*/

searchClass.searchHistory = function(){

    // 검색 로컬스토리 로드

    var citylistArr = JSON.parse(storageClass.searchHistory("get"))



    // 로컬스토리 값 있을 경우
    if(citylistArr != null && typeof(citylistArr) != "undefined"){

        // 순서 변경
        citylistArr = citylistArr.reverse();

        //// 지역 노출 갯수 제한
        //if(locationClass.historycount <= citylistArr.length){
        //    citylistArr = citylistArr.slice(0,locationClass.historycount);
        //}

        // 지역 데이터 tmpl 처리
        searchClass.renderList(citylistArr,true);
    }

};


/* ========================================================== 검색 입력시 지역 자동 검색  ==============================================================*/

// 검색 이벤트 및 텍스트필드 설정
searchClass.searchEvent = function(){


    // 키입력 이벤트
    $("#locationinput_text").keypress(function () {
        setTimeout(function(){
            searchClass.loadCityList($("#locationinput_text").val());
        },100)
    });

    // 텍스트 포커스 설정
    $("#locationinput_text").bind("focus",function(event){
        if($(this).attr("focused")=="true")return;
        $(this).attr("focused","true");
        $(this).val("");
        //$('#login_password').get(0).type = 'password';
        $(this).css("color","#363636");
    })
};


// 지역 검색
searchClass.cityApiUrl = "/places/search?query=name:^";
searchClass.cityListUrl = function(queryTxt){
    var url = coreClass.apiDomain+searchClass.cityApiUrl+encodeURI(queryTxt.toLowerCase())+"&limit=20&sort=place";
    url += coreClass.key;
    return url;
};

// 날씨 API 로드
searchClass.loadCityList = function(queryTxt){
    var loadurl = searchClass.cityListUrl(queryTxt);
    console.log(loadurl);
    $.ajax({
        type: "get",
        url :  loadurl,
        success: function(data) {
            if(data.success == true){
                console.log("loadCityList success");
                searchClass.renderList(data.response);
            }else{
                console.log("data parsing");
                // data = JSON.parse(data);
            }
        }
    });
}


/* ========================================================== 검색 위치명 및 내역 Dom 로드 ==============================================================*/

searchClass.renderList = function(result,recent){
    $("#searchList").empty();
    $("#locationinput_text").blur()

    for(var i in result){

        //위경도 좌표값이 정상일때 렌더링
        //지역명 또는 위도 경도좌표가 없을때는 히스토리에 저장하지 않음
        if(result[i].place.stateFull+result[i].place.countryFull == ""){
            return;
        }

        if(typeof(result[i].loc.lat) == "undefined" || typeof(result[i].loc["long"]) == "undefined" ||
            result[i].loc.lat*1 == 0 || result[i].loc["long"]*1 == 0 ||
            result[i].loc.lat*1 == -1000 || result[i].loc["long"]*1 == -1000){
            return;
        }

        var data = {};

        data.areaname = result[i].place.name;
        data.lat =  result[i].loc.lat;
        data.long =  result[i].loc.long;
        data.country =  result[i].place.countryFull;


        // 검색 위치명 리스트
        var domName = "locationSearchList";

        if(recent){

            // 최근 검색한 위치명 리스트
            domName = "locationHistory"
        }

        commonClass.appendDom("#searchList",domName,data)

        if(i == result.length-1){
            scrollClass.addpage_Scroll("option",0,"location");
        }


    };
}


/* ========================================================== 검색위치 선택 이벤트 ==============================================================*/



searchClass.selectCityName = function(lat, long, area, country){
    optionClass.refreshController=true;

    // 광클릭 방지 딜레이
    if(searchClass.selectCityNameEnable == false){
        return;
    }
    searchClass.selectCityNameEnable = false;
    setTimeout(function(){
        searchClass.selectCityNameEnable = true;
    },1000);



    //지역명 또는 위도 경도좌표가 없을때는 히스토리에 저장하지 않음
    if(area == "" ||country == "" ){
        console.log("save list fail 지역테이터 누락");
        return;
    }

    if(lat*1 == 0 || long*1 == 0 ||
        lat*1 == -1000 || long*1 == -1000){
        console.log("save list fail 위경도 데이터 비정상");
        return;
    }

    // 선택한 위치 로컬스토리 불러오기
    var citylistArr = JSON.parse(storageClass.searchHistory("get"))
    var newCityList = [];

    // 선택한 도시 정보
    var data = {};
    data.loc = {}
    data.place = {}

    data.loc.lat = lat;
    data.loc.long = long;
    data.place.name = area;
    data.place.countryFull = country;


    // 검색 내역이 저장되어있지 않은 경우
    if(citylistArr == null) {
        newCityList.push(data);

        // 저장시 배열 형식에서 '\' 로 구분되어 JSOM 파싱 사용
        storageClass.searchHistory("set", JSON.stringify(newCityList))

    }else{

        for(var i in citylistArr){
            if(citylistArr[i].place.name !=  data.place.name){
                newCityList.push(citylistArr[i])

                if(newCityList.length >5){

                    // 첫번쨰 배열 지우기
                    newCityList.shift()
                }

            }

            if(citylistArr.length - 1 == i){
                newCityList.push(data);



                // 저장시 배열 형식에서 '\' 로 구분되어 JSOM 파싱 사용
                storageClass.searchHistory("set", JSON.stringify(newCityList))
            }
        }
    }
    // 옵션페이지 검색 명 변경
    $("#current_location_text").text(area)
    $("#uploadPhotoArea").text(area)


    locationClass.lat = lat;

    // 경도
    locationClass.longi =long;



    // 도시이름
    locationClass.areaname = area
    // 국가이름
    locationClass.country = country;


    $("#confrim_location").text(locationClass.areaname.toUpperCase());

    // 디바이스 위치설정 오프된 경우 로케이션 페이지에서 지역 선택시 자동으로 메인페이지 재로드
    if( locationClass.directLocation == true ){
        main_logicClass.resetmainData(lat,long)
    }


    // 페이지 닫기
    eventmanagerClass.big_popup_hidden('location');



   // $("#main_dom").remove()
   // pagemanager.pageopen_event('main','main','bottom',null,'scroll')
  //  main_logicClass.resetmainData()

};

/* ========================================================== 검색위치 삭제  ==============================================================*/
searchClass.deleteLocation = function(uid,area){

    // 알림팝업
    //utilClass.showMessage("Delete this location?","Take Weather",
    //    function(button){
    //        weather.log(button);
    //        if(button == 2)return;
    //        deleteLoc();
    //    }
    //    ,"Yes,No"
    //);

    // 검색 위치 삭제
    deleteLoc();
    function deleteLoc(){

        //돔제거
        $("#historyList_"+uid).remove();

        var newlistArr = [];
        var citylistArr = JSON.parse(storageClass.searchHistory("get"))


        for(var i in citylistArr){
            if(citylistArr[i].place.name != area){
                newlistArr.push(citylistArr[i])
            }

            if(citylistArr.length - 1 == i){
                storageClass.searchHistory("set",JSON.stringify(newlistArr))
            }

        }

    }
}

/* ========================================================== 지역검색어 삭제 ==============================================================*/

searchClass.locationInputRemove = function(){
    $("#locationinput_text").val('');
};
