var shareClass = {};



/* ========================================================== 캡쳐영역 구성 ==============================================================*/

/*

 캡쳐영역 구성 : share(1x), save(2x)
 광클릭 방지 : shareClass.eventDelay

 */

// 이벤트 딜레이
shareClass.eventDelay = false;

shareClass.setContents = function(type){

    if(shareClass.eventDelay == true){
        return
    }

    shareClass.eventDelay = true;

    // 캡쳐 Dom 초기화
    $("#captureContent").empty();

    //버튼 effect
    $("#share_tap > li > a").removeClass();
    $("#nav_share_"+type+" > a").addClass("hover")


    // 변수 설정
    var multiple = 750;
    var sizeClass = "tw-share";
    var callback;

    if(type == "save"){


        multiple = 1500;
        sizeClass = "tw-share-x2"
        eventmanagerClass.bottom_popup_hidden()
        setTimeout(function(){
            eventmanagerClass.bottom_popup_view('save')
            $("#center_loading_cover").css("display","block")
        },200)

    }else{
        //로딩바 표시
        $("#center_loading_icon").css("display","block")
        $("#center_loading_cover").css("display","block")
    }

    // Contents UID, DATA 추출
    var uid = commonClass.uiddata_load(eventmanagerClass.currentUid)
    console.log(uid)

    var apiName = "/api/readpostbyid";


    // API call
    $.post(utilClass.noneCachePostUrl(configClass.domain+apiName), {
        postid:uid.post_id
    }, function(data) {

        // 데이터 없는 경우
        if(typeof(data.list)=="undefined" || data.length<=0){

            return;
        }

        // 데이터 설정
        var item =data.list[0];

        var dateObj = item.post_rdate_format.split(" ")[0].split("-");
        var timeObj = item.post_rdate_format.split(" ")[1].split(":");
        var currentDate = new Date(dateObj[0], dateObj[1]-1, dateObj[2],timeObj[0],timeObj[1],timeObj[2]);

        var O_dateObj = item.post_servertime.split(" ")[0].split("-");
        var O_timeObj = item.post_servertime.split(" ")[1].split(":");
        var offsetTime = new Date(O_dateObj[0], O_dateObj[1]-1, O_dateObj[2],O_timeObj[0],O_timeObj[1],O_timeObj[2]);

        offsetTime.setTime(offsetTime.getTime() + (-540*60*1000)); //서버 타임이 한국 기준으로 되어 있어 표준시로 변경
        var n = new Date().getTimezoneOffset() * 60 * 1000;
        offsetTime.setTime(offsetTime.getTime() - n);



        // 국가별 날짜표시 변환
        if(configClass.iskorean == true){
            //한국식
            item.post_rdate_txt = item.post_rdate_format.split(" ")[0] +" "+ utilClass.dayTextArr[currentDate.getDay()];
            console.log(item.post_rdate_txt)
        }else{
            //영미권식
            item.post_rdate_txt = utilClass.dayTextArr[offsetTime.getDay()] +"-"+utilClass.monthTextArr[offsetTime.getMonth()]+" " + utilClass.twoString(offsetTime.getDate())+"-"+offsetTime.getFullYear();
            console.log(item.post_rdate_txt)
        }

        // 시간표시
        if(currentDate.getHours()<12){
            item.post_posttime =  "AM "+utilClass.twoString(currentDate.getHours())+":"+utilClass.twoString(currentDate.getMinutes());
        }else{
            if(currentDate.getHours()==12){
                item.post_posttime = "PM "+utilClass.twoString(currentDate.getHours())+":"+utilClass.twoString(currentDate.getMinutes());
            }else{
                item.post_posttime = "PM "+utilClass.twoString(currentDate.getHours()-12)+":"+utilClass.twoString(currentDate.getMinutes());
            }

        }
        item.icon = item.post_icon

        // 온도 (기본 섭씨)
        item.temptxt = utilClass.fixTemp(item.post_temp)+"°";

        // 사진
        item.post_photo = configClass.domain + item.post_photo;

        // 도시이름 대문자 처리
        item.post_areaname_upper = item.post_areaname.toUpperCase()

        // class 속성변경 (2x : tw-share-x2, 1x : tw-share )
        item.size = sizeClass;


        commonClass.appendDom("#captureContent","contents",item)

        $("#capture").attr("src",item.post_photo+"_big.jpg");

        // 이미지 로드 처리
        $("#capture").load(function(){

            // 그릴 캔버스
            var newWidth = multiple;
            var newHeight = multiple * (4/3);


            // Dom 크기처리
            $("#captureContent").css("width",newWidth);
            $("#captureContent").css("height",newHeight);

            var canvas = document.getElementById('canvas');

            // 캔버스 크기 설정
            canvas.setAttribute('width',newWidth);
            canvas.setAttribute('height',newHeight);
            var ctx = canvas.getContext('2d');


            // 대상 이미지 캡쳐 : url 이미지 직접 캡쳐할 경우 security 문제로 canvas 처리 후 캡쳐
            var img = document.getElementById('capture');

            drawImageProp(ctx, img, 0, 0, canvas.width, canvas.height,0.5,0.5)
            //ctx.drawImage(img,0,0,newWidth,newHeight);

            // 캡쳐
            if(type =="facebook"){
                callback = shareClass.shareToFacebook
            }
            if(type =="insta"){
                callback = shareClass.shareInstagram
            }
            if(type =="other"){
                callback = shareClass.otherShare
            }
            if(type =="save"){
                callback = shareClass.saveImage
            }

            shareClass.captureImg(callback)

        });

        // 이미지 로드 에러 처리
        $("#cature").error(function(){
            shareClass.eventDelay = false;
            utilClass.showMessage("Image load fail");
            return;
        })

    });
};

function drawImageProp(ctx, img, x, y, w, h, offsetX, offsetY) {

    if (arguments.length === 2) {
        x = y = 0;
        w = ctx.canvas.width;
        h = ctx.canvas.height;
    }

    /// default offset is center
    offsetX = offsetX ? offsetX : 0.5;
    offsetY = offsetY ? offsetY : 0.5;

    /// keep bounds [0.0, 1.0]
    if (offsetX < 0) offsetX = 0;
    if (offsetY < 0) offsetY = 0;
    if (offsetX > 1) offsetX = 1;
    if (offsetY > 1) offsetY = 1;

    var iw = img.width,
        ih = img.height,
        r = Math.min(w / iw, h / ih),
        nw = iw * r,   /// new prop. width
        nh = ih * r,   /// new prop. height
        cx, cy, cw, ch, ar = 1;

    /// decide which gap to fill
    if (nw < w) ar = w / nw;
    if (nh < h) ar = h / nh;
    nw *= ar;
    nh *= ar;

    /// calc source rectangle
    cw = iw / (nw / w);
    ch = ih / (nh / h);

    cx = (iw - cw) * offsetX;
    cy = (ih - ch) * offsetY;

    /// make sure source rectangle is valid
    if (cx < 0) cx = 0;
    if (cy < 0) cy = 0;
    if (cw > iw) cw = iw;
    if (ch > ih) ch = ih;

    /// fill image in dest. rectangle
    ctx.drawImage(img, cx, cy, cw, ch,  x, y, w, h);
}


/* ==========================================================  캡쳐  ==============================================================*/
/*

 사진저장 및 공유시 캡쳐기능 사용

 */

// 캡쳐상태
shareClass.captured = false;

// 이미지 캡쳐
shareClass.captureImg = function(callback){

    // 캡쳐상태 초기화
    shareClass.captured = false;

    // 사이즈 이미지 렌더링
    html2canvas(document.getElementById("captureContent"), {
            logging: true,
            allowTaint:true,
            useCORS: true,

            onrendered: function(canvasdata) {

                // 캡쳐 상태 : 완료
                shareClass.captured = true;

                // 캡쳐 영역 초기화
                $("#captureContent").empty();

                // 디바이스 크기에 맞게 드로잉
                var canvas = document.getElementById('shareCanvas');
                var oldWidth = 900;
                var oldHeight = 1200;


                canvas.setAttribute('width',oldWidth);
                canvas.setAttribute('height',oldHeight);
                //canvas.setAttribute('width',oldWidth);
                //canvas.setAttribute('height',oldHeight);
                var ctx = canvas.getContext('2d');
                var img = new Image();
                img.onload = function(){

                    ctx.drawImage(img,0,0,oldWidth,oldHeight);

                    // 드로잉 이미지 저장
                    shareClass.sharecanvas = canvas.toDataURL("image/jpeg",1);

                    //로딩바 사라짐
                    $("#center_loading_icon").css("display","none")
                    $("#center_loading_cover").css("display","none")

                    //callback - share ,  save :  shareClass.deviceImgSave()
                    callback();

                    // 이벤트 딜레이 초기화
                    shareClass.eventDelay = false
                };
                //$("#imgtest").attr("src",canvasdata.toDataURL("image/jpeg",1))
                img.src = canvasdata.toDataURL("image/jpeg",1);

            }}
    );
};



/* ========================================================== 공유 - 페이스북 ==============================================================*/


shareClass.shareToFacebook=function(){

    facebookConnectPlugin.login(["public_profile"],

        // 접속 성공시 콜백호출
        function () {
            shareClass.facebookshare()
        },
        // 접속 실패시 콜백 호출
        function (error) {
           // utilClass.showMessage("facebook connect error");
        }
    );
};

shareClass.facebookshare = function(){

    // https://github.com/EddyVerbruggen/SocialSharing-PhoneGap-Plugin
    // cordova plugin add cordova-plugin-x-socialsharing
    // 페이스북 연결 요청
    facebookConnectPlugin.getLoginStatus(function(response) {

        // 페이스북 연결 성공
        if (response.status === 'connected') {

            window.plugins.socialsharing.shareViaFacebook('facebook', shareClass.sharecanvas , null /* url */, function() {console.log('share ok')}, function(errormsg){console.log(errormsg)})

        } else if (response.status === 'not_authorized') {
            utilClass.showMessage("facebook not_authorized");
        } else {
            utilClass.showMessage("facebook share fail");
        }


    })
}


/* ========================================================== 공유 - 인스타그램 ==============================================================*/


shareClass.shareInstagram = function(){

    // 인스타 설치 확인
    Instagram.isInstalled(function (err, installed) {

        if (installed) {
            console.log("Instagram is", installed); // installed app version on Android


            // 인스타 공유

            var caption = "caption"
            Instagram.share( shareClass.sharecanvas, caption, function (err) {
                if (err) {
                   //utilClass.showMessage("Instagram share fail");
                } else {
                    //utilClass.showMessage("instagram share");
                }
            });


        } else {
            utilClass.showMessage("Instagram is not installed")
        }
    });
};


/* ========================================================== 공유 - other apps ==============================================================*/

shareClass.otherShare = function(){

    // 이미지 문자열로 전환
    var imageData = shareClass.sharecanvas
    var caption = ""

    try{
        window.plugins.socialsharing.share(caption, null, imageData, null)
    }catch(e){
        utilClass.showMessage("other apps share fail")
    }


}






/* ========================================================== 공유 - 이미지 저장 ==============================================================*/

shareClass.saveImage = function(){

    window.canvas2ImagePlugin.saveImageDataToLibrary(
        function(msg){

            // $('#tw-app-buttons').addClass('tw-button-caution');
            $("#center_loading_cover").css("display","none")
            $('#tw-closeoverlay').attr("class","off")
            $('#tw-message').removeClass();

        },
        function(err){
            utilClass.showMessage("Image save fail")
        },
        document.getElementById('shareCanvas')
    );
};


